﻿unit uJumpListExpert;

interface

uses
   ToolsAPI, Classes, Windows, SysUtils;

type
  TJumpListExprt = class(TNotifierObject, IOTAWizard, IOTAMenuWizard)
  public
    { IOTAWizard }
    function GetIDString: string;
    function GetName: string;
    function GetState: TWizardState;
    procedure Execute;

    { IOTAMenuWizard }
    function GetMenuText: string;
 end;

  procedure Register;

implementation

uses
  uJumpList, ActiveX, ShlObj;

function GetAppPath: String;
var
  Path: PChar;
begin
  Path := AllocMem(MAX_PATH + 1);

  GetModuleFileName(0, Path, MAX_PATH);
  Result := Path;

  FreeMem(Path);;
end;

{ TCustomMenuHandler }

procedure TJumpListExprt.Execute;
var
  JL: TJumplist;
  Task: TTaskItem;

  AppId: PChar;
  Path: String;
begin
  if Not CheckWin32Version(6, 1) then Exit;

  GetCurrentProcessExplicitAppUserModelID(AppId);
  JL := TJumplist.Create(AppId);
  if Assigned(AppId) then
    CoTaskMemFree(AppId);

  Path := GetAppPath;

  Task := TTaskItem.Create;
  Task.Path := Path;
  Task.Argument := '-pDelphi';
  Task.Title := 'Delphi XE';
  Task.Description := 'Delphi パーソナリティを起動します';
  Task.IconLocation := Path;
  Task.IconIndex := 0;
  JL.Tasks.Add(Task);

  Task := TTaskItem.Create;
  Task.Path := Path;
  Task.Argument := '-pCBuilder';
  Task.Title := 'C++Builder XE';
  Task.Description := 'C++Builder パーソナリティを起動します';
  Task.IconLocation := Path;
  Task.IconIndex := 0;
  JL.Tasks.Add(Task);

  JL.CreateJumpList;

  FreeAndNil(JL);
end;

function TJumpListExprt.GetIDString: string;
begin
  Result := 'AU2010.CreateJumpListExpert';
end;

function TJumpListExprt.GetMenuText: string;
begin
  Result := 'Create JumpList';
end;

function TJumpListExprt.GetName: string;
begin
  Result := 'CreateJL';
end;

function TJumpListExprt.GetState: TWizardState;
begin
  if CheckWin32Version(6, 1) then
    Result := [wsEnabled]
  else
    Result := [];
end;

procedure Register;
begin
  RegisterPackageWizard(TJumpListExprt.Create);
end;

end.
